#!/bin/bash
conda activate raffle_env   

# Define all your sets here.
sets="
v0_r15_w0_g0_m85
v0_r15_w0_g85_m0
v0_r15_w85_g0_m0
v85_r15_w0_g0_m0
"

# Store the starting directory so we can return to it after each iteration.
homedir=$(pwd)

# Loop over each set in the variable 'sets'
for set in $sets; do
    echo "Processing set: $set"

    # Parse out the v, r, w, g, and m values using sed
    v=$(echo "$set" | sed -E 's/.*v([0-9]+).*/\1/')
    r=$(echo "$set" | sed -E 's/.*r([0-9]+).*/\1/')
    w=$(echo "$set" | sed -E 's/.*w([0-9]+).*/\1/')
    g=$(echo "$set" | sed -E 's/.*g([0-9]+).*/\1/')
    m=$(echo "$set" | sed -E 's/.*m([0-9]+).*/\1/')

    # Create a directory named DTMP_<set>
    mkdir -p "DTMP_$set"
    cd "DTMP_$set" || exit 1

    echo "  - In directory: $(pwd)"
    method_str="method_val = [$v.0, $r.0, $w.0, $g.0, $m.0]"
    echo "  - Updating learn.py to set $method_str"

    # Edit the line in learn.py
    # The sed expression looks for a line that starts with optional indentation,
    # then '#method_val = [whatever] #change', and replaces it with the new method_val array.
    sed -i "s/method_val = \[.*\]/$method_str/" ../../example/python_pkg/Al_learn/learn.py

    # Run the python script
    python ../../example/python_pkg/Al_learn/learn.py

    # Move back to the original homedir
    cd "$homedir" || exit 1
done
